Attribute VB_Name = "mCalc"
Option Explicit

Global Htbl(15) As String

Public Function B2D(sSrc As String) As String
'2i10i
    On Error GoTo ErrB2D
    Dim sSplitSrc() As String
    Dim I As Long
    Dim sDec As String
    Dim J As Long
    Dim sTmp As String
    Dim lLen As Long
    If Trim(sSrc) = "" Then
        B2D = ""
        Exit Function
    End If
    sSplitSrc = Split(sSrc, " ", , vbTextCompare)
    For I = LBound(sSplitSrc) To UBound(sSplitSrc)
        If Len(sSplitSrc(I)) > 0 Then
            If sSplitSrc(I) = "1" Then
                sDec = sDec & "1 "
            Else
                For J = 1 To Len(sSplitSrc(I))
                    If Mid(sSplitSrc(I), J, 1) = "1" Then
                        Exit For
                    End If
                Next J
                sTmp = "1" & Mid(sSplitSrc(I), J * 2)
                sDec = sDec & CStr(BIN2DEC(sTmp)) & " "
            End If
        End If
    Next I
    B2D = sDec
ExitB2D:
    Exit Function
ErrB2D:
    Resume ExitB2D
End Function

Public Function D2B(sSrc As String) As String
'10i2i
    Dim sSplitSrc() As String
    Dim I As Long
    Dim lSrc As Long
    Dim sTmp As String
    Dim sGamma As String
    Dim sBin As String
    Dim lLen As Long
On Error GoTo ErrD2B
    If Trim(sSrc) = "" Then
        D2B = ""
        Exit Function
    End If
    sSplitSrc = Split(sSrc, " ", , vbTextCompare)
    For I = LBound(sSplitSrc) To UBound(sSplitSrc)
        If Len(sSplitSrc(I)) > 0 Then
            lSrc = StrConv(Val(sSplitSrc(I)), vbNarrow)
            If lSrc = 1 Then
                sBin = sBin & "1 "
            Else
                sTmp = DEC2BIN(lSrc)
                lLen = Len(sTmp)
                sGamma = DEC2BIN(lLen)
                sBin = sBin & String(Len(sGamma) - 1, "0") & sGamma & Mid(sTmp, 2) & " "
            End If
        End If
    Next I
    D2B = sBin
EXITD2B:
    Exit Function
ErrD2B:
    Resume EXITD2B
End Function

Public Function B2H(sSrc As String) As String
'2i16i
    On Error GoTo ErrB2H
    Dim sBin As String
    Dim I As Long
    If Trim(sSrc) = "" Then
        B2H = ""
        Exit Function
    End If
    For I = 1 To Len(sSrc)
        If Mid(sSrc, I, 1) <> " " Then
            sBin = sBin & Mid(sSrc, I, 1)
        End If
    Next I
    
    If Len(sBin) Mod 8 <> 0 Then
        sBin = sBin & String(8 - (Len(sBin) Mod 8), "0")
    End If
    Dim sHex As String
    For I = 1 To Len(sBin) / 8
        sHex = sHex & Hex(BIN2DEC(Mid(sBin, (I - 1) * 8 + 1, 8))) & " "
    Next I
    B2H = sHex

ExitB2H:
    Exit Function
ErrB2H:
    Resume ExitB2H
End Function

Public Function H2B(sSrc As String) As String
'16i2i
    Dim sHex As String
    Dim sTmp As String
    Dim idx As Long
    Dim I As Long
    On Error GoTo ErrH2B
    MakeHtbl
    sTmp = Trim(sSrc)
    If Len(sTmp) = 0 Then
        H2B = ""
        Exit Function
    End If
    sHex = ""
    For I = 1 To Len(sTmp)
        If Mid(sTmp, I, 1) <> " " Then
            sHex = sHex & Right("0000" & DEC2BIN(Val("&H" & Mid(sTmp, I, 1))), 4)
        End If
    Next I
    Dim iPos As Long
    Dim iStart As Long
    Dim sBin As String
    Dim iKeta As Long
    
    iPos = 1
    iStart = 1
    Do While iPos < Len(sHex) + 1
        If Mid(sHex, iPos, 1) = "1" Then
            If iPos = iStart Then
                sBin = sBin & "1 "
                iPos = iPos + 1
                iStart = iStart + 1
            Else
                sTmp = Mid(sHex, iPos, iPos - iStart + 1)
                iKeta = BIN2DEC(sTmp)
                iPos = iPos + (iPos - iStart + 1)
                iPos = iPos + iKeta - 1
                sBin = sBin & Mid(sHex, iStart, iPos - iStart) & " "
                iStart = iPos
            End If
        Else
            iPos = iPos + 1
        End If
    Loop
    H2B = sBin
ExitH2B:
    Exit Function
ErrH2B:
    Resume ExitH2B
End Function

Public Function BIN2DEC(sSrc As String) As Long
    Dim I As Long
    Dim S As Long
    For I = 1 To Len(sSrc)
        S = S * 2
        If Mid(sSrc, I, 1) = "1" Then
            S = S + 1
        End If
    Next I
    BIN2DEC = S
End Function

Public Function DEC2BIN(lSrc As Long) As String
    Dim sBin As String
    
    Do While lSrc
        sBin = IIf((lSrc Mod 2) = 1, "1", "0") & sBin
        lSrc = lSrc \ 2
    Loop
    DEC2BIN = sBin
End Function

Public Function MakeHtbl()
    Htbl(0) = "0000"
    Htbl(1) = "0001"
    Htbl(2) = "0010"
    Htbl(3) = "0011"
    Htbl(4) = "0100"
    Htbl(5) = "0101"
    Htbl(6) = "0110"
    Htbl(7) = "0111"
    Htbl(8) = "1000"
    Htbl(9) = "1001"
    Htbl(10) = "1010"
    Htbl(11) = "1011"
    Htbl(12) = "1100"
    Htbl(13) = "1101"
    Htbl(14) = "1110"
    Htbl(15) = "1111"
End Function

